on run argv
	(* Gets passed:
		       APP_RESOURCES,  			# Arg 1
                     ROOT_APP_SUPPORT,               	# Arg 2
                     CURRENT_OS_USER,                	# Arg 3
                     str(reinstallResources),        	# Arg 4
                     str(shouldAlsoStartService),    	# Arg 5

                     str(rsyncExists),               		# Arg 6
                     str(rsyncdLaunchDaemonExists),  # Arg 7
                     str(rsyncdConfExists),          	# Arg 8
                     str(thisUsersConfExists),       	# Arg 9
                     str(pathToPreparedUserConf),    	# Arg 10

                     str(stunnelExists),             		# Arg 11
                     str(stunnelLaunchDaemonExists), # Arg 12
                     str(stunnelConfExists),         	# Arg 13
                     str(stunnelCertExists),         	# Arg 14
                     str(stunnelKeyExists),          	# Arg 15
                     str(pathToPreparedKeys)]        	# Arg 16
	*)
	
	set APP_RESOURCES to item 1 of argv
	set ROOT_APP_SUPPORT to item 2 of argv
	set CURRENT_OS_USER to item 3 of argv
	set reinstallResources to (item 4 of argv as boolean)
	set shouldAlsoStartService to (item 5 of argv as boolean)
	
	set rsyncExists to (item 6 of argv as boolean)
	set rsyncdLaunchDaemonExists to (item 7 of argv as boolean)
	set rsyncdConfExists to (item 8 of argv as boolean)
	set thisUsersConfExists to (item 9 of argv as boolean)
	set pathToPreparedUserConf to item 10 of argv
	
	set stunnelExists to (item 11 of argv as boolean)
	set stunnelLaunchDaemonExists to (item 12 of argv as boolean)
	set stunnelConfExists to (item 13 of argv as boolean)
	set stunnelCertExists to (item 14 of argv as boolean)
	set stunnelKeyExists to (item 15 of argv as boolean)
	set pathToPreparedKeys to item 16 of argv
	
	
	-- We deserve this at the very least...
	do shell script "mkdir -p " & quoted form of ROOT_APP_SUPPORT with administrator privileges
	
	
	if (not rsyncExists) or reinstallResources then
		set source to quoted form of (APP_RESOURCES & "/rsync")
		set destination to quoted form of (ROOT_APP_SUPPORT & "/rsync")
		do shell script "cp -f " & source & " " & destination with administrator privileges
	end if
	
	if (not rsyncdLaunchDaemonExists) or reinstallResources then
		set source to quoted form of (APP_RESOURCES & "/com.backaroo.rsyncd.plist")
		set destination to quoted form of ("/Library/LaunchDaemons/com.backaroo.rsyncd.plist")
		do shell script "cp -f " & source & " " & destination with administrator privileges
		do shell script "chown root " & destination with administrator privileges
	end if
	
	if (not rsyncdConfExists) or reinstallResources then
		set source to quoted form of (APP_RESOURCES & "/rsyncd.conf")
		set destination to quoted form of (ROOT_APP_SUPPORT & "/rsyncd.conf")
		do shell script "cp -f " & source & " " & destination with administrator privileges
	end if
	
	if (not thisUsersConfExists) or reinstallResources then
		set source to quoted form of pathToPreparedUserConf
		set destination to quoted form of (ROOT_APP_SUPPORT & "/rsyncd-confs/" & CURRENT_OS_USER & ".conf")
		do shell script "mkdir -p " & quoted form of (ROOT_APP_SUPPORT & "/rsyncd-confs") with administrator privileges
		do shell script "mv -f " & source & " " & destination with administrator privileges
	end if
	
	
	
	if (not stunnelExists) or reinstallResources then
		set source to quoted form of (APP_RESOURCES & "/stunnel")
		set destination to quoted form of (ROOT_APP_SUPPORT & "/stunnel")
		do shell script "cp -f " & source & " " & destination with administrator privileges
	end if
	
	if (not stunnelLaunchDaemonExists) or reinstallResources then
		set source to quoted form of (APP_RESOURCES & "/com.backaroo.stunnel.plist")
		set destination to quoted form of ("/Library/LaunchDaemons/com.backaroo.stunnel.plist")
		do shell script "cp -f " & source & " " & destination with administrator privileges
		do shell script "chown root " & destination with administrator privileges
	end if
	
	if (not stunnelConfExists) or reinstallResources then
		set source to quoted form of (APP_RESOURCES & "/stunnel.conf")
		set destination to quoted form of (ROOT_APP_SUPPORT & "/stunnel.conf")
		do shell script "cp -f " & source & " " & destination with administrator privileges
	end if
	
	-- If either public or private key are missing: replace both (forcibly)
	if (not stunnelCertExists) or (not stunnelKeyExists) or reinstallResources then
		-- Move the certificate
		set source to quoted form of (pathToPreparedKeys & "/stunnel-cert.pem")
		set destination to quoted form of (ROOT_APP_SUPPORT & "/stunnel-cert.pem")
		do shell script "mv -f " & source & " " & destination with administrator privileges
		-- Move the private key
		set source to quoted form of (pathToPreparedKeys & "/stunnel-key.pem")
		set destination to quoted form of (ROOT_APP_SUPPORT & "/stunnel-key.pem")
		do shell script "mv -f " & source & " " & destination with administrator privileges
		do shell script "chown root " & destination with administrator privileges
		do shell script "chmod 700 " & destination with administrator privileges
	end if
	
	
	if shouldAlsoStartService then
		do shell script "launchctl load -F /Library/LaunchDaemons/com.backaroo.rsyncd.plist" with administrator privileges
		do shell script "launchctl load -F /Library/LaunchDaemons/com.backaroo.stunnel.plist" with administrator privileges
		do shell script "defaults write /Library/LaunchDaemons/com.backaroo.rsyncd.plist Disabled -boolean NO" with administrator privileges
		do shell script "defaults write /Library/LaunchDaemons/com.backaroo.stunnel.plist Disabled -boolean NO" with administrator privileges
	end if
	
	
	
	
end run

